//package com.example.afrishop_v3.controllers;
//
//import com.diaoyun.zion.chinafrica.constant.KeyConstant;
//import com.diaoyun.zion.chinafrica.entity.TbCfOrderEntity;
//import com.diaoyun.zion.chinafrica.enums.OrderStatusEnum;
//import com.diaoyun.zion.chinafrica.service.PayPalService;
//import com.diaoyun.zion.chinafrica.service.TbCfOrderService;
//import com.diaoyun.zion.chinafrica.vo.TbCfOrderVo;
//import com.diaoyun.zion.master.base.Result;
//import com.diaoyun.zion.master.common.RedisCache;
//import com.diaoyun.zion.master.config.PaypalPaymentIntent;
//import com.diaoyun.zion.master.config.PaypalPaymentMethod;
//import com.diaoyun.zion.master.enums.ResultCodeEnum;
//import com.example.afrishop_v3.base.Result;
//import com.example.afrishop_v3.bo.KeyConstant;
//import com.example.afrishop_v3.config.PaypalPaymentIntent;
//import com.example.afrishop_v3.config.PaypalPaymentMethod;
//import com.example.afrishop_v3.enums.OrderStatusEnum;
//import com.example.afrishop_v3.enums.ResultCodeEnum;
//import com.example.afrishop_v3.models.TbCfOrder;
//import com.example.afrishop_v3.repository.TbCfOrderRepository;
//import com.paypal.api.payments.Links;
//import com.paypal.api.payments.Payment;
//import com.paypal.base.rest.APIContext;
//import io.swagger.annotations.Api;
//import io.swagger.annotations.ApiOperation;
//import io.swagger.annotations.ApiParam;
//import org.apache.commons.lang3.StringUtils;
//import org.slf4j.Logger;
//import org.slf4j.LoggerFactory;
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.beans.factory.annotation.Value;
//import org.springframework.web.bind.annotation.*;
//
//import javax.annotation.Resource;
//import javax.servlet.http.HttpServletRequest;
//import javax.servlet.http.HttpServletResponse;
//import java.math.BigDecimal;
//import java.util.Date;
//import java.util.Optional;
//
///**
// * @Auther: wudepeng
// * @Date: 2020/11/10
// * @Description:paypal支付
// */
//@RestController
//@RequestMapping(value = "/paypal")
//public class PaypalContoller {
//
//    private static Logger logger = LoggerFactory.getLogger(PaypalContoller.class);
//
//    @Value("${paypal.success_url}")
//    private String PAYPAL_SUCCESS_URL;
//
//    @Value("${paypal.cancel_url}")
//    private String PAYPAL_CANCEL_URL;
//
//    @Value("${paypal.success_page}")
//    private String PAYPAL_SUCCESS_PAGE;
//
//    @Value("${paypal.failed_page}")
//    private String PAYPAL_FAILED_PAGE;
//
//    @Autowired
//    private APIContext apiContext;
//
//    @Autowired
//    private TbCfOrderRepository orderRepository;
//
//    /**
//     * 发起paypal支付
//     *
//     * @param orderId 订单号
//     * @return Result
//     */
//    @PostMapping("/payment/{orderId}")
//    public Result payment(@PathVariable("orderId") String orderId) {
//        Result result = new Result();
//        //==========================支付信息校验==========================
//
//        //订单号
//        if (StringUtils.isBlank(orderId)) {
//            logger.error("paypal支付，订单Id不能为空");
//            return payErrorInfo(result);
//        }
//
////        //从缓存中获取订单信息
////        TbCfOrderVo orderCache = (TbCfOrderVo) orderRedisCache.get(KeyConstant.ORDER_DET + orderId);
////
////        if (orderCache == null) {
////            //订单已过期或者不存在
////            logger.error("paypal支付，订单不存在");
////            return payErrorInfo(result);
////        }
//
//        //订单信息
//        Optional<TbCfOrder> byId = orderRepository.findById(orderId);
//        if (byId.isPresent()) {
//            TbCfOrder order = byId.get();
//            //价格不存在或错误
//            if (order.getRealityPay() == null || order.getRealityPay().compareTo(BigDecimal.ZERO) <= 0) {
//                logger.error("paypal支付，订单[" + order.getOrderNo() + "]价格错误");
//                return payErrorInfo(result);
//            }
//
//
//            //订单已支付
//            if (OrderStatusEnum.PAID.getValue().equals(order.getPayStatus().toString())) {
//                logger.error("paypal支付，订单[" + order.getOrderNo() + "]已支付");
//                return payErrorInfo(result);
//            }
//
//
//            //价格转double类型
//            BigDecimal realityPay = order.getRealityPay();
//            String price = realityPay.toString();
//            double orderPrice = Double.parseDouble(price);
//
//            //==========================paypal支付业务开始==========================
//
//            logger.info("paypal支付开始，时间：" + new Date());
//            String orderInfo = order.getDeliveryName() + "'s payment information";
//            logger.info(orderInfo);
//            String currency = "USD";
//            try {
//                Payment payment = payPalService.payment(
//                        orderId,
//                        orderPrice,
//                        currency,
//                        PaypalPaymentMethod.paypal,
//                        PaypalPaymentIntent.sale,
//                        orderInfo,
//                        PAYPAL_CANCEL_URL,
//                        PAYPAL_SUCCESS_URL);
//
//                String paymentId = payment.getId();
//                orderRedisCache.set(KeyConstant.ORDER_DET + "_" + paymentId, orderId);
//                logger.info("paypal支付完成，时间：" + new Date());
//                for (Links links : payment.getLinks()) {
//                    if (links.getRel().equals("approval_url")) {
//                        return result.setData(links.getHref());
//                    }
//                }
//            } catch (Exception e) {
//                logger.info("paypal支付发生异常，时间：" + new Date() + e.getMessage());
//                return payErrorInfo(result);
//            }
//        }
//
//        return payErrorInfo(result);
//    }
//
//    /**
//     * 支付失败提示
//     *
//     * @param result
//     */
//    public Result payErrorInfo(Result result) {
//        result.setCode(ResultCodeEnum.ORDER_PAY_ERROR.getCode());
//        result.setMessage(ResultCodeEnum.ORDER_PAY_ERROR.getDesc());
//        return result;
//    }
//}
